# Ubuntu with KasmVNC
CTN_NAME="ubuntu-kasm"
CTN_MEM=$(get_podcfg $CTN_NAME CTN_MEM)
CTN_PORT=$(get_podcfg $CTN_NAME CTN_PORT)
CTN_IMAGE=$(get_podcfg $CTN_NAME CTN_IMAGE)
CTN_SRC=$(get_podcfg $CTN_NAME CTN_SRC)
CTN_WORKDIR=$(get_podcfg $CTN_NAME CTN_WORKDIR)
CTN_VERSION_NAME=$(get_podcfg $CTN_NAME CTN_VERSION_NAME)
CTN_INTERNAL_PORT=$(get_podcfg $CTN_NAME CTN_INTERNAL_PORT)
IS_PROXY=$([[ -n $CFG_DOMAIN_PROXY ]] && echo true || echo false)
user_volume_list="home/kasm-user"
root_volume_list="boot root etc home opt usr srv"

pod_run() {
    u_volume_list=""
    r_volume_list=""
    for _v in $user_volume_list; do
        [[ -d $CFG_LIVE_DATA/$CTN_WORKDIR/$_v ]] && u_volume_list+="$_v "
    done
    for _v in $root_volume_list; do
        [[ -d $CFG_LIVE_DATA/$CTN_WORKDIR/$_v ]] && r_volume_list+="$_v "
    done

    mkdir -p $CFG_SHARE_DIR
    # CAP SYS_ADMIN for nexcloud mount point using mount/fuse
    podman run --dns=$DNS_CTN_IP --dns=$GATEWAY_IP --memory $CTN_MEM \
               --name=$CTN_NAME --hostname=$CTN_NAME --network=$NETWORK_NAME --detach \
               --cap-add SYS_ADMIN --device /dev/fuse \
               -v "$CFG_SHARE_DIR":/shared \
               -v "$CFG_LIVE_DATA/$(get_podcfg symfony CTN_WORKDIR)/www":/symfony \
               -e VNC_PW=$CFG_DEFAULT_PASSWORD -e VNC_VIEW_ONLY_PW=$CFG_DEFAULT_PASSWORD \
               $(_list=""; for _v in $u_volume_list; do _list+="-v $CFG_LIVE_DATA/$CTN_WORKDIR/$_v:/$_v:Z,U "; done; echo "$_list") \
               $(_list=""; for _v in $r_volume_list; do _list+="-v $CFG_LIVE_DATA/$CTN_WORKDIR/$_v:/$_v:Z "; done; echo "$_list") \
               $(eval $IS_PROXY || echo "--publish=$CTN_PORT:$CTN_INTERNAL_PORT") \
               --expose "80/tcp" --expose "443/tcp" --expose $CTN_INTERNAL_PORT \
               $CTN_SRC/$CTN_IMAGE
}


# Remote configuration jobs (// tasks after containers run())
pod_config() {
    #TODO: 1) edit kasm-user unix user instead of created new one
    #TODO: 2) configure also the vnc user and viewer with vncpasswd
    #_extra_setup_cmd="(sleep 10; echo -e \"$CFG_DEFAULT_PASSWORD\n$CFG_DEFAULT_PASSWORD\n\" | tee ~/pwd.txt | vncpasswd -u $CFG_DEFAULT_USERNAME -rw)&"
    #add_setup_cmd_to_ctn "$CTN_NAME" "$_extra_setup_cmd" "postmaster password"

    # For proxy, add redirection to main directory from it
    _extra_setup_cmd="cd /usr/share/kasmvnc/www && ln -fs . $CTN_NAME"
    add_setup_cmd_to_ctn "$CTN_NAME" "$_extra_setup_cmd" "www/ symlink for proxy"

    # Get desired persistant fs
    sleep 10
    is_new_folder=false
    for _v in $user_volume_list $root_volume_list; do
        if ! [[ -d $CFG_LIVE_DATA/$CTN_WORKDIR/$_v ]]; then
            mkdir -p $CFG_LIVE_DATA/$CTN_WORKDIR/$(dirname $_v)
            podman cp $CTN_NAME:/$_v $CFG_LIVE_DATA/$CTN_WORKDIR/$_v &> /dev/null || rm -rf $CFG_LIVE_DATA/$CTN_WORKDIR/$_v
            is_new_folder=true
        fi
    done

    if $is_new_folder; then
        podman rm -f $CTN_NAME &> /dev/null || return 1
        pod_run &> /dev/null || return 1
    fi
}

#pod_post_config() {
#}
